import type { QuestType, ResourcesType } from "./types";
import { getEmptyResources, random } from "./utils";


let uid = 0;


export function createQuest(level: number): QuestType {
    const reward = getEmptyResources();
    const adjustedLevel = level * level + 3;
    const duration = random(adjustedLevel - 2, adjustedLevel + 2);
    Object.keys(reward).forEach(r => {
        const resource = r as keyof ResourcesType;
        reward[resource] = random(
            Math.round((duration * 5 - level * 10) * (1 + level / 3)),
            Math.round((duration * 5 + level * 10) * (1 + level / 3)),
        );

        if (resource === 'culture') {
            reward[resource] = Math.round(reward[resource] / 20);
        }
    });

    return {
        id: uid++,
        duration,
        reward,
        level,
        started: false,
    };
}
